Index: trunk/kernel/arch/ibmpc/arch-config.h
===================================================================
--- trunk/kernel/arch/ibmpc/arch-config.h	(revision 1)
+++ trunk/kernel/arch/ibmpc/arch-config.h	(revision 1)
@@ -0,0 +1,55 @@
+/*
+ * arch.c - architecture related configurations
+ *
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _ARCH_CONFIG_H_
+#define _ARCH_CONFIG_H_
+
+#ifndef _CONFIG_H_
+#error This config-file is not to be included directely, use config.h instead
+#endif
+
+//////////////////////////////////////////////
+//      ARCH RELATED CONFIGURATIONS         //
+//////////////////////////////////////////////
+#define CONFIG_USR_OFFSET       0x00C00000
+#define CONFIG_USR_LIMIT        0x01F00000
+#define CONFIG_CPU_BITS_NR               2
+#define CONFIG_CLUSTER_BITS_NR           2
+#define CONFIG_CLUSTER_NR                1
+#define CONFIG_CPU_PER_CLUSTER_NR        1
+#define CONFIG_CPU_NR                    1
+#define CONFIG_IO_CLUSTER_ID             0
+#define CONFIG_BOOT_CLUSTER_ID           0
+#define CONFIG_BOOT_CPU_ID               0
+#define CONFIG_TTY_DEV_NR                1
+#define CONFIG_DMSG_KLOG_TTY             0
+#define CONFIG_DMSG_BOOT_TTY             0
+#define CONFIG_DMSG_ISR_TTY              0
+#define CONFIG_DMSG_EXCEPT_TTY           0
+#define CONFIG_KSH_TTY                   0
+#define CONFIG_TIMER_WITH_IRQ            yes
+#define CONFIG_TTY_ECHO_MODE             yes
+#define CONFIG_FB_USE_DMA                no
+//////////////////////////////////////////////
+
+
+#endif	/* _ARCH_CONFIG_H_ */
Index: trunk/kernel/arch/ibmpc/arch.c
===================================================================
--- trunk/kernel/arch/ibmpc/arch.c	(revision 1)
+++ trunk/kernel/arch/ibmpc/arch.c	(revision 1)
@@ -0,0 +1,51 @@
+/*
+ * arch.c - architecture related operations (see kern/hal-arch.h)
+ *
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include <errno.h>
+#include <types.h>
+#include <kdmsg.h>
+#include <cpu.h>
+#include <device.h>
+#include <system.h>
+
+error_t arch_cpu_init(struct cpu_s *cpu)
+{
+	cpu->arch.action = NULL;
+	return 0;
+}
+
+error_t arch_cpu_set_irq_entry(struct cpu_s *cpu, int irq_nr, struct irq_action_s *action)
+{
+	assert(cpu->arch.action == NULL && "IRQ entry has been already specified\n");
+	cpu->arch.action = action;
+	return 0;
+}
+
+error_t arch_cpu_get_irq_entry(struct cpu_s *cpu, int irq_nr, struct irq_action_s **action)
+{
+	if(cpu->arch.action == NULL)
+		return EINVAL;
+
+	cpu->arch.action->data = (void*)irq_nr;
+	*action = cpu->arch.action;
+	return 0;
+}
Index: trunk/kernel/arch/ibmpc/arch.h
===================================================================
--- trunk/kernel/arch/ibmpc/arch.h	(revision 1)
+++ trunk/kernel/arch/ibmpc/arch.h	(revision 1)
@@ -0,0 +1,74 @@
+/*
+ * arch.h - architecture specific implementation of kernel's HAL
+ * (see kern/hal-arch.h)
+ *
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _ARCH_H_
+#define _ARCH_H_
+
+#include <config.h>
+#include <segmentation.h>
+#include <types.h>
+
+#ifndef _HAL_ARCH_H_
+#error arch.h connot be included directly, use system.h instead
+#endif
+
+/* CPUs/CLUSTERs Numbers */
+#define CACHE_LINE_SIZE   CONFIG_CACHE_LINE_SIZE
+#define __CPU_NR          CONFIG_CPU_NR
+#define __CPUs            CONFIG_CPU_PER_CLUSTER_NR
+#define __CLUSTER_NR      CONFIG_CLUSTER_NR
+#define __CPU_BITS_NR     CONFIG_CPU_BITS_NR
+#define __CLUSTER_BITS_NR CONFIG_CLUSTER_BITS_NR
+#define __PAGE_SIZE       CONFIG_CACHE_LINE_SIZE
+
+#undef CPU_NR
+#undef CLUSTER_NR
+#undef CPU_PER_CLUSTER
+#undef GET_CPU_ID
+#undef GET_CLUSTER_ID
+#undef MAKE_CPU_ID
+
+#define CPU_NR                      __CPU_NR
+#define CLUSTER_NR                  __CLUSTER_NR
+#define CPU_PER_CLUSTER             __CPUs
+#define GET_CPU_ID(_cpu_id)         ((_cpu_id) & (__CPU_NR - 1))
+#define GET_CLUSTER_ID(_cpu_id)     ((_cpu_id) >> __CPU_BITS_NR)
+#define MAKE_CPU_ID(_cluster,_cpu)  (((_cluster) << __CPU_BITS_NR) | (_cpu))
+
+/* Timer parameters macros */
+#undef TIC
+#undef CYCLES_PER_SECOND
+
+#define TIC                 40000
+#define CYCLES_PER_SECOND   200000
+#define ALPHA               20
+
+/* Structures definitions */
+struct irq_action_s;
+
+struct arch_cpu_s
+{
+	struct irq_action_s *action;
+};
+
+#endif	/* _ARCH_H_ */
Index: trunk/kernel/arch/ibmpc/arch_init.c
===================================================================
--- trunk/kernel/arch/ibmpc/arch_init.c	(revision 1)
+++ trunk/kernel/arch/ibmpc/arch_init.c	(revision 1)
@@ -0,0 +1,90 @@
+/*
+ * arch_init.c - architecture intialization operations (see kern/hal-arch.h)
+ *
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include <config.h>
+#include <types.h>
+#include <hardware.h>
+#include <cpu.h>
+#include <device.h>
+#include <driver.h>
+#include <list.h>
+#include <pic.h>
+#include <tty.h>
+#include <scheduler.h>
+#include <kdmsg.h>
+#include <devfs.h>
+#include <cluster.h>
+#include <rt_timer.h>
+#include <pci-bus.h>
+#include <kmem.h>
+#include <ata.h>
+
+/* TODO: dynamicly calculate this value on each icu bind operation */
+#define ICU_MASK     0x3  // interrupt enabled for frist 2 devices 
+
+struct device_s __sys_dma;
+struct device_s __fb_screen;
+struct device_s __sys_blk;
+struct device_s rt_timer;
+
+static void ioCluster_init(struct cluster_s *cluster, uint_t id)
+{
+	struct device_s *pic;
+	int i;
+
+	/* First of all: Initialize TTYs */
+	ibmpc_tty_init(&ttys_tbl[0], __tty_addr, 1, 0);   // IRQ 0 is taken by Timer 0
+
+	boot_dmsg("\nSetup Terminal \t\t\t\tOK\n");
+   
+	cluster_init(cluster, id, __CPU_NR);
+
+	boot_dmsg("Setup PIC      ");
+	pic = kbootMem_calloc(sizeof(*pic));
+	ibmpc_pic_init(pic, __pic_addr, 0);
+	ibmpc_pic_bind(pic, &ttys_tbl[0]);
+	devfs_register(&ttys_tbl[0]);
+
+	for(i=0; i < __CPU_NR; i++)
+		arch_cpu_set_irq_entry(&cluster->cpu_tbl[i], 0, &pic->action);
+
+	boot_dmsg("\t\t\t\tOK\nSetup Timer    ");
+	rt_timer_init(TIC, 1);
+	ibmpc_pic_bind(pic, &rt_timer);
+
+	boot_dmsg("\t\t\t\tOK\nSetup H.D.D    ");
+	ibmpc_ata_init(&__sys_blk, (void*)ATA0_DRIVE0, 14);
+	ibmpc_pic_bind(pic, &__sys_blk);
+
+	boot_dmsg("\t\t\t\tOK\nActivating IRQs");
+	pic->op.icu.set_mask(pic, ICU_MASK, 0, 0);
+	boot_dmsg("\t\t\t\tOK\n");
+}
+
+
+error_t arch_init(void)
+{
+	kdmsg_init();
+	ioCluster_init(&clusters_tbl[IO_CLUSTER_ID], IO_CLUSTER_ID);
+
+	return 0;
+}
Index: trunk/kernel/arch/ibmpc/hardware.h
===================================================================
--- trunk/kernel/arch/ibmpc/hardware.h	(revision 1)
+++ trunk/kernel/arch/ibmpc/hardware.h	(revision 1)
@@ -0,0 +1,49 @@
+/*
+ * hardware.h - architecture specific macros
+ *
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _HARDWARE_H_
+#define _HARDWARE_H_
+
+#include <config.h>
+#include <segmentation.h>
+#include <types.h>
+#include <system.h>
+#include <screen.h>
+/* Addresses of the peripheral devices */
+#define __pic_addr        ((uint_t*)PIC_BASE)
+#define __tty_addr        ((uint_t*)TTY_BASE)
+#define __fb_addr         ((uint_t*)FB_BASE)
+#define __timer_addr      ((uint_t*)TIMER_BASE)
+#define __dma_addr        ((uint_t*)DMA_BASE)
+#define __blk_addr        ((uint_t*)BD_BASE)
+
+#define IO_CLUSTER_ID     CONFIG_IO_CLUSTER_ID
+
+/* Terminals related macros */
+#define TTY_DEV_NR        CONFIG_TTY_DEV_NR
+#define SYS_TTY           0
+#define TTY_BUFFER_DEPTH  40
+
+/* Timer parameters macros */
+#define TIMER_DEV_NR      CONFIG_TIMER_DEV_NR
+
+#endif	/* _HARDWARE_H_ */
Index: trunk/kernel/arch/ibmpc/kdmsg.c
===================================================================
--- trunk/kernel/arch/ibmpc/kdmsg.c	(revision 1)
+++ trunk/kernel/arch/ibmpc/kdmsg.c	(revision 1)
@@ -0,0 +1,131 @@
+/*
+ * kdmsg.c - output kernel debug/trace/information to an available terminal
+ * (see kern/kdmsg.h)
+ *
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include <types.h>
+#include <hardware.h>
+#include <cpu.h>
+#include <device.h>
+#include <tty.h>
+#include <libk.h>
+#include <kdmsg.h>
+#include <spinlock.h>
+
+spinlock_t exception_lock;
+spinlock_t printk_lock;
+spinlock_t isr_lock;
+
+void kdmsg_init()
+{
+	spinlock_init(&exception_lock);
+	spinlock_init(&printk_lock);
+	spinlock_init(&isr_lock);
+}
+
+int __fprintk (int tty, spinlock_t *lock, const char *fmt, ...)
+{
+	va_list ap;
+	int count;
+	char buff[256];
+	dev_request_t rq;
+
+	va_start (ap, fmt);
+
+	assert(tty == 0 && "Unexpected tty device id");
+	count = iprintk (buff, 1, (char *) fmt, ap);
+	assert(count < 256 && "Buffer overflow");
+
+	va_end (ap);
+	rq.src   = buff;
+	rq.count = count;
+	rq.flags = DEV_RQ_NOBLOCK;
+
+	if(lock)
+	{
+		if(lock == &printk_lock)
+			spinlock_lock(&ttys_tbl[tty].lock);
+		else
+			cpu_spinlock_lock(&ttys_tbl[tty].lock.val);
+	}
+
+	ttys_tbl[tty].op.dev.write(&ttys_tbl[tty], &rq);
+   
+	if(lock)
+	{
+		if(lock == &printk_lock)
+			spinlock_unlock(&ttys_tbl[tty].lock);
+		else
+			cpu_spinlock_unlock(&ttys_tbl[tty].lock.val);
+	}
+
+	return count;
+}
+
+int __perror (int fatal, const char *fmt, ...)
+{
+	va_list ap;
+	int count;
+	char buff[256];
+	dev_request_t rq;
+
+	va_start (ap, fmt);
+	count = iprintk (buff, 1, (char *) fmt, ap);
+	va_end (ap);
+   
+	rq.src = buff;
+	rq.count = count;
+	rq.flags = DEV_RQ_NOBLOCK;
+
+	ttys_tbl[0].op.dev.write(&ttys_tbl[0], &rq);
+
+	if(fatal)
+		while(1);
+
+	return count;
+}
+
+void bdump(uint_t fd, char* buff, size_t count)
+{
+	register uint_t i,j,size;
+	char *tab = "0123456789ABCDEF";
+	char tmp[256];
+	dev_request_t rq;
+     
+	assert((fd != 0) && "file descriptor is not a tty");
+	i=0;
+
+	while(count)
+	{
+		size = (count < 256) ? count : 256;
+    
+		for(j=0; j < size; j++, i++)
+			tmp[j] = tab[ (buff[i] & 0xF)];
+		
+		rq.src   = tmp;
+		rq.count = 256;
+		rq.flags = 0;
+    
+		ttys_tbl[0].op.dev.write(&ttys_tbl[0], &rq);
+
+		count -= size;
+	}
+}
Index: trunk/kernel/arch/ibmpc/kldscript.h
===================================================================
--- trunk/kernel/arch/ibmpc/kldscript.h	(revision 1)
+++ trunk/kernel/arch/ibmpc/kldscript.h	(revision 1)
@@ -0,0 +1,49 @@
+/*
+ * kldscript.h - kernel ldscript
+ *
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+ENTRY(_start)
+phys = 0x00100000;
+SECTIONS
+{
+  .text phys : AT(phys) {
+    code = .;
+    *(.boot)
+    *(.text)
+    *(.rodata*)
+    _ecode = .;
+    . = ALIGN(4096);
+  }
+  .data : AT(phys + (data - code))
+  {
+    data = .;
+    *(.data)
+    . = ALIGN(4096);
+  }
+  .bss : AT(phys + (bss - code))
+  {
+    bss = .;
+    *(.bss)
+    . = ALIGN(4096);
+  }
+  _edata = .;
+  _end = .;
+}
Index: trunk/kernel/arch/ibmpc/kldscript.h2
===================================================================
--- trunk/kernel/arch/ibmpc/kldscript.h2	(revision 1)
+++ trunk/kernel/arch/ibmpc/kldscript.h2	(revision 1)
@@ -0,0 +1,57 @@
+/*OUTPUT_FORMAT("binary")*/
+ENTRY(_start)
+phys = 0x00100000;
+SECTIONS
+{
+  .text phys : AT(phys) {
+    code = .;
+    *(.boot)
+    *(.text)
+    _ecode = .;
+    . = ALIGN(4096);
+  }
+
+  .eh_frame : AT(phys + (_eh_frame - code))
+  {
+    _eh_frame = .;
+    *(.rodata*)
+    *(.data)
+    . = ALIGN(4096);
+  }
+
+  .data : AT(phys + (data - code))
+  {
+    data = .;
+    *(.rodata*)
+    *(.data)
+    . = ALIGN(4096);
+  }
+
+  .bss : AT(phys + (bss - code))
+  {
+    bss = .;
+    *(.bss)
+    . = ALIGN(4096);
+  }
+  _edata = .;
+  _end = .;
+
+  .comment : AT(phys + (_comment - code))
+  {
+    _comment = .;
+    *(.comment*)
+  }
+
+  .stab : AT(phys + (_stab - code))
+  {
+    _stab = .;
+    *(.stab*)
+  }
+
+  .stabstr : AT(phys + (_stabstr - code))
+  {
+    _stabstr = .;
+    *(.stabstr*)
+  }
+}
+/*INPUT(__do_syscall.o)*/
Index: trunk/kernel/arch/ibmpc/rt_timer.c
===================================================================
--- trunk/kernel/arch/ibmpc/rt_timer.c	(revision 1)
+++ trunk/kernel/arch/ibmpc/rt_timer.c	(revision 1)
@@ -0,0 +1,104 @@
+/*
+ * rt_timer.c - real-time timer related operations
+ *
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include <types.h>
+#include <rt_timer.h>
+#include <cpu.h>
+#include <device.h>
+#include <driver.h>
+#include <sysio.h>
+#include <thread.h>
+#include <kmem.h>
+
+extern struct device_s rt_timer;
+
+static void timer_irq_handler (struct irq_action_s *action)
+{
+	register struct cpu_s *cpu;
+	register struct thread_s *this;
+   
+	this = CURRENT_THREAD;
+	cpu = this->local_cpu;
+
+	if(this->type == PTHREAD)
+	{
+		MEM_CHECK(this->info.usr_stack_base);
+	}
+   
+	MEM_CHECK(this->info.sys_stack_base);
+   
+	cpu->alarm_mgr.action.irq_handler(&cpu->alarm_mgr.action);
+
+	cpu->tics_nr ++;
+	cpu->tics_count ++;
+	sched_clock(this);
+}
+
+/** Initialize Real-Time timer source */
+error_t rt_timer_init(uint_t period, uint_t withIrq)
+{
+	rt_timer.irq = 0;
+	rt_timer.action.irq_handler = &timer_irq_handler;
+	rt_timer.type = DEV_TIMER;
+
+	strcpy(rt_timer.name, "TIMER");
+	metafs_init(&rt_timer.node, rt_timer.name);
+
+	return 0;
+}
+
+/** Read Real-Time timer current value  */
+error_t rt_timer_read(uint_t *time)
+{
+	*time = CURRENT_THREAD->local_cpu->tics_nr * 20;
+	return 0;
+}
+
+/** Set Real-Time timer's current value */
+error_t rt_timer_set(uint_t time)
+{
+	return 0;
+}
+
+/** Set Real-Time timer's period */
+error_t rt_timer_setperiod(uint_t period)
+{
+	return 0;
+}
+
+/** Send commands to Real-Time timer device */
+error_t rt_timer_ctrl(struct rt_params_s *param)
+{
+	switch(param->rt_cmd)
+	{
+	case RT_TIMER_STOP:
+		//rt_timer.op.timer.stop(&rt_timer);
+		return 0;
+
+	case RT_TIMER_RUN:
+		//rt_timer.op.timer.run(&rt_timer, (uint_t)rt_timer.data);
+		return 0;
+
+	default:
+		return -1;
+	}
+}
Index: trunk/kernel/arch/ibmpc/segmentation.h
===================================================================
--- trunk/kernel/arch/ibmpc/segmentation.h	(revision 1)
+++ trunk/kernel/arch/ibmpc/segmentation.h	(revision 1)
@@ -0,0 +1,41 @@
+/*
+ * segmentation.h - physical address space known segments
+ *
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+//////////////////////////////////////////////
+//         Devices mapped segments 
+//////////////////////////////////////////////
+#define     TIMER_BASE  0xd3200000
+#define     TIMER_SIZE  0x00000080
+
+#define     PIC_BASE    0x00000020
+
+#define     TTY_XSIZE   80
+#define     TTY_YSIZE   25
+#define     TTY_BASE    0x000B8000  
+#define     TTY_SIZE    TTY_XSIZE*TTY_YSIZE*2
+
+#define     ATA0_DRIVE0 0x000001F0
+#define     ATA0_DRIVE1 0x000101F0
+
+#define     ATA1_DRIVE0 0x00000170
+#define     ATA1_DRIVE1 0x00010170
+//////////////////////////////////////////////
Index: trunk/kernel/arch/tsar/arch-config.h
===================================================================
--- trunk/kernel/arch/tsar/arch-config.h	(revision 1)
+++ trunk/kernel/arch/tsar/arch-config.h	(revision 1)
@@ -0,0 +1,72 @@
+/*
+ * arch.c - architecture related configurations
+ *
+ * Copyright (c) 2007,2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _ARCH_CONFIG_H_
+#define _ARCH_CONFIG_H_
+
+#ifndef _CONFIG_H_
+#error This config-file is not to be included directely, use config.h instead
+#endif
+
+//////////////////////////////////////////////
+//      ARCH RELATED CONFIGURATIONS         //
+//////////////////////////////////////////////
+#define CONFIG_ARCH_NAME             "tsar"
+#define CONFIG_THREAD_PAGE_ORDER     0x1
+#define RUN_IN_PHYSICAL_MODE         yes
+#define CONFIG_PHYSICAL_BITS	     40
+#define CONFIG_LOCAL_PHYSICAL_BITS   32//NUMBER of bits that are local to a cluster
+
+/* Kepping the same value for KERNEL_OFFSET allow us to 
+ * have the same kernel for both mode of addressing */
+#if RUN_IN_PHYSICAL_MODE
+
+ /* kernel space allocated virtual addresses */
+ #define CONFIG_KERNEL_OFFSET         0x00000000
+ #define CONFIG_KERNEL_LIMIT          0x00003FFF //approximated may require more (if less no problem)
+ #define CONFIG_DEVREGION_SIZE        0x00000000 //empty
+ /* user space allocated virtual addresses */
+ #define CONFIG_USR_OFFSET            0x00004000
+ #define CONFIG_USR_LIMIT             0x80000000//0xFFFFFFFF
+
+#else /*!RUN_IN_PHYSICAL_MODE*/
+
+ /* kernel space allocated virtual addresses */
+ #define CONFIG_KERNEL_OFFSET         0x00000000
+ #define CONFIG_KERNEL_LIMIT          0x3FFFFFFF
+ #define CONFIG_DEVREGION_SIZE        0x00000000 //Dynamically allocated from kernel space
+ /* drivers are physically accessed !? */
+ /* user space allocated virtual addresses */
+ #define CONFIG_USR_OFFSET            0x40000000
+ #define CONFIG_USR_LIMIT             0xFFFFFFFF
+
+#endif
+
+#define CONFIG_PPN_BITS_NR                20
+#define CONFIG_TTY_ECHO_MODE              yes
+#define CONFIG_TTY_MAX_DEV_NR             32
+#define CONFIG_TTY_BUFFER_DEPTH           40
+#define CONFIG_FB_USE_DMA                 no
+#define CONFIG_ARCH_HAS_BARRIERS          no
+//////////////////////////////////////////////
+
+#endif	/* _ARCH_CONFIG_H_ */
